var pubArgu = {
	swiperPages: [],
	swiperMain: null,
	tagBar: null,
	swiperBody: null,
	goWordLock: 0, //是否停止上下词跳转
	headHeight: null,
	windowHeight: null,
	tagBarHeight: null,
	showBrowserMenu: null, //标记浏览器长按菜单是否已显示
	listenVoiceObj: null, //全局发音对象
}; //公用的全局变量

$(function(){
	var $canvas,needlisten = 1;
	function fixPageHeight(){
		pubArgu.windowHeight = document.documentElement.clientHeight;
	    $('#swiperMain').css('height', pubArgu.windowHeight);
	}
	init();
	function init(){
		FastClick.attach(document.body);
		fixPageHeight();
		$.swiperInit.init(); //滑动组件初始化

		bindClickEvent(); //绑定页面元素点击事件

		$('.tabBar').each(function(){
			tabBarClick(this);
		});

		drawChart(); //绘制饼图
		$canvas = $('canvas');

		startDrawPie(); //初始检测是否需要绘制饼图

		scrollListener(); //页面滚动监听

		tellNativeUserSelText();//每次用户选择文本改变时，告知客户端选择的文本内容

		//捕获阶段全局阻挡多点触控
		document.addEventListener('touchstart',function(e){
			if(e.touches.length > 1) e.stopPropagation();
		},true);

		$.commFun.resizeSwiper($('.main'));

	}

	//每次用户选择文本改变时，告知客户端选择的文本内容
	function tellNativeUserSelText(){
		var delayClickable;
		document.onselectionchange = function(){
			var str = window.getSelection().toString();
		    tellSelectText(str);
		    if(delayClickable){
		    	clearTimeout(delayClickable);
		    	delayClickable = null;
		    }
		    if(str.length){
		    	pubArgu.showBrowserMenu = 1;
		    }
		    else {
		    	delayClickable = setTimeout(function(){
		    		pubArgu.showBrowserMenu = 0;
		    		delayClickable = null;
		    	},400);
		    }
		}
	}

	//绘制饼图
	function drawChart(){
		$('#posStat .statChart').drawPieChart({"data":posData});
		$('#senseStat .statChart').drawPieChart({"data":senseData});
	}

	//页面滚动监听
	function scrollListener(){
		// $(window).scroll(startDrawPie);
		var oldfun = pubArgu.swiperMain.params.onSetTranslate,count=0;
		pubArgu.swiperMain.params.onSetTranslate = function(s,val){
			oldfun(s,val);
			if(needlisten && count++ > 6){
				count = 0;
				startDrawPie();
			}
		}
		pubArgu.swiperMain.params.onTransitionEnd = function(s){
			if(needlisten){
				startDrawPie();
			}
		}
	}
	//开始绘制饼图
	function startDrawPie(){
		var hadDrawNum = 0;
		$canvas.each(function(){
			if(!this.hadDraw){
				var top = this.getBoundingClientRect().top;
				if(top < pubArgu.windowHeight - 100 && top > 0){
					$.drawPieChart.firstDraw(this);
					this.hadDraw = 1;
				}
			}
			else {
				hadDrawNum++;
			}
		});
		if(hadDrawNum == $canvas.length){
			needlisten = 0;
		}
	}

	//绑定页面元素点击事件
	function bindClickEvent(){
		var $main = $('.main');
		//标签栏点击事件
		$main.on('click','.tabBar',function(e){
			e.stopPropagation();
			tabBarClick(this);
		});
	}

	//标签栏点击事件
	function tabBarClick(This){
		var $This = $(This);
		var parent = $This.parent();
		parent.toggleClass('show');
		$.commFun.resizeSwiper($This);
	}

});
