var pubArgu = {
	swiperPages: [],
	swiperMain: null,
	tagBar: null,
	swiperBody: null,
	goWordLock: 0,
	headHeight: null,
	windowHeight: null,
	tagBarHeight: null,
	showBrowserMenu: null, //标记浏览器长按菜单是否已显示
	listenVoiceObj: null, //全局发音对象
}; //公用的全局变量

$(function(){
	var curIndex;
	init();
	function init(){
		FastClick.attach(document.body);

		pubArgu.tagBarHeight = $('#tagBar').height() || 0;
		$.commFun.fixPageHeight();
		pubArgu.headHeight = -1*$('#header').height() || 0;
		
		$.swiperInit.init(); //滑动组件初始化

		bindClickEvent(); //绑定页面元素点击事件

		//文本搜索初始化
		$('#searchText').searchText({"hideIcon": $('.fixIconBtn'), "rootNode": swiperMain, "specharRexpType": 2, "foldLabelList": ["sections","hideExp","hideExpSen"], "iconsConflictFun": tagMenuConflict});
		
		
		tellNativeUserSelText();//每次用户选择文本改变时，告知客户端选择的文本内容

		//浏览器窗口改变时，重置swiper
		$(window).on("resize",$.commFun.windowSizeSwiper);
		
		//捕获阶段全局阻挡多点触控
		document.addEventListener('touchstart',function(e){
			if(e.touches.length > 1) e.stopPropagation();
		},true);

		$.jumpPosition.init();

	}

	//绑定页面元素点击事件
	function bindClickEvent(){
		var $con = $("#header").parent();
		//播放声音按钮点击事件
		$con.on('click','.playSound',function(e){
			e.stopPropagation();
			if(pubArgu.listenVoiceObj != this){ //不等于自己，先冲突检测，再播放新的音频
				clickConflictTest();
				pubArgu.listenVoiceObj = this;
				var $this = $(this);
				$this.addClass("loading");
				var bodyIndex = pubArgu.tagBarHeight ? pubArgu.swiperBody.activeIndex : "-1";
				var jsonD = {"name": $this.attr("name"), "lang": $this.attr("lang"), "type": 1, "uwid": $this.parent().attr("uwid"), "classname": "playSound", "bodyIndex": bodyIndex, "objIndex": $this.attr("index")};
				requestAudioUrl(jsonD);
			}
			else { //当前按钮正处于激活状态
				if($.audioPlayer.isHandleMe(this)){ //等待播放后停止
					$.audioPlayer.stopPlay();
				}
			}
		});
		//添加收藏图标点击事件
		$con.on('click','.addStar',function(e){
			e.stopPropagation();
			var $this = $(this);
			var $parent = $this.parent();
			var uwid = $parent.attr('uwid') || $parent.parent().attr('uwid');
			if($parent.hasClass("exampleIcon")){
				addScb({"uwid": uwid, "source": "1", "keypath":$this.attr('keypath'), "parentuwid": $this.attr('parentuwid')});
			}
			else {
				addScb({"uwid": uwid, "source": "0"});
			}
		});
		//语音测评按钮点击事件
		$con.on('click','.recordSound',function(e){
			e.stopPropagation();
			clickConflictTest();
			beginEvaluating({"uwid": $(this).parent().parent().attr('uwid')});
		});
		//播放录音按钮点击事件
		$con.on('click','.listenSound',function(e){
			e.stopPropagation();
			if(pubArgu.listenVoiceObj != this){ //不等于自己，先冲突检测，再播放新的音频
				clickConflictTest();
				pubArgu.listenVoiceObj = this;
				var $this = $(this);
				var uwid = $this.parent().parent().attr("uwid");
				var jsonD = {"name": uwid, "type": 2, "uwid": uwid, "classname": "listenSound"};
				requestAudioUrl(jsonD);
			}
			else { //当前按钮正处于激活状态
				if($.audioPlayer.isHandleMe(this)){ //等待播放后停止
					$.audioPlayer.stopPlay();
				}
			}
		});
		//fullname标签点击弹出补充说明
		addsInstTitle = addsInstTitle || {};
		$con.on('click','fullname',function(e){
			e.stopPropagation();
			var $this = $(this);
			viewAddsInstruction({"showWay":"html", "templateName": "abbreviation_explain","senseId": $(this).attr("index"), "uwid": $this.attr("subuwid"), "title":addsInstTitle.fullname});
		});
		//er跳转标签点击事件
		$con.on('click','er',function(e){
			$.commFun.erClickEvent.call(this,e);
		});
		
		//tabBar点击事件
		$con.on("click",".tabBar",function(e){
			e.stopPropagation();
			tabBarClick(this);
		});
		//折叠例句按钮点击事件
		$("#sense").on('click','.hideExpSenBtn',function(e){
			e.stopPropagation();
			var $This = $(this);
			$This.parent().parent().toggleClass('hideExpSen');
			$.commFun.resizeSwiper($This);
		});
		//隐藏中文按钮点击事件
		$("#sense").on('click','.hideChBtn',function(e){
			e.stopPropagation();
			var $This = $(this);
			$con.toggleClass('hideCh');
			$.commFun.resizeSwiper($This);
			if($con.hasClass('hideCh')){
				pageState.showCh = 0;
			}
			else {
				pageState.showCh = 1;
			}
			changeShowChSet({"showCh": pageState.showCh});
		});

		//--------------------右下角菜单区点击事件----------------------
		var $fixIconBtn = $('.fixIconBtn');
		//"更多"（用户菜单）按钮点击事件
		$fixIconBtn.on('click','#userMenu',function(e){
			e.stopPropagation();
			var fixIconBtn = $(this).parent();
			fixIconBtn.toggleClass("active");
			if(fixIconBtn.hasClass("active")){
				this.timeout = setTimeout(function(){
					tagMenuIconClick();
					this.timeout = null;
				},200);
			}
			else {
				tagMenuConflict();
			}
		});
		//设置菜单按钮点击事件
		$fixIconBtn.on('click','#userSetting',function(e){
			e.stopPropagation();
			tagMenuConflict();
			$(this).parent().removeClass('active').addClass('hideAway');
			openSettingPanel();
		});
		//右下角标签菜单点击事件
		$fixIconBtn.on('click','#tagMenu>div',function(e){
			e.stopPropagation();
			var $this = $(this);
			if(!$this.hasClass('active')){
				$('#tagMenu div.active').removeClass('active');
				$this.addClass('active');
			}
			var aim = $('#'+$this.attr('aim'));
			aim.addClass('show');
			$.commFun.resizeSwiper(aim);
			$.commFun.jumpToAim(aim);
			var parents = $this.parent().parent();
			parents.addClass('hasClick');
			setTimeout(function(){
				tagMenuIcon.className = "";
				parents.removeClass('hasClick active showTagMenu');
			},300);
		});
		//tagMenuIcon按钮点击事件
		$fixIconBtn.on('click','#tagMenuIcon',function(e){
			e.stopPropagation();
			tagMenuIconClick();
		});
	}

	//标签栏点击事件
	function tabBarClick(This){
		var $This = $(This);
		var parent = $This.parent();
		parent.toggleClass('show');
		$.commFun.resizeSwiper($This);
	}
	
	//tagMenuIcon按钮点击事件绑定方法
    function tagMenuIconClick(){
        var $this = $(tagMenuIcon);
        var $parent = $this.parent();
        if($this.hasClass('active')){
            $this.removeClass('active');
            $parent.removeClass('showTagMenu');
        }
        else {
            $this.addClass('active');
            $parent.addClass('showTagMenu');
            var id = $.commFun.testActiveTag();
            if(id != curIndex){
                curIndex = id;
                $('#tagMenu .active').removeClass('active');
                $('#tagMenu div').eq(curIndex).addClass('active');
            }
            $('#swiperMain').one('touchstart',function(){
                $parent.removeClass('active showTagMenu');
                tagMenuIcon.className = "";
            });
        }
    }
	
	//右下角折叠释义按钮点击事件
	function foldingExp(){
		$(this.aim).removeClass('show');
		var moreexp = $(this.aim).prev();
		moreexp.removeClass("hide");
		$(this).removeClass("show");
		$.commFun.resizeSwiper($(this.aim));
		return moreexp;
	}

	//每次用户选择文本改变时，告知客户端选择的文本内容
	function tellNativeUserSelText(){
		var delayClickable;
		document.onselectionchange = function(){
			if($.searchText.isSerTextIng()) return;
			var str = window.getSelection().toString();
		    tellSelectText(str);
		    if(delayClickable){
		    	clearTimeout(delayClickable);
		    	delayClickable = null;
		    }
		    if(str.length){
		    	pubArgu.showBrowserMenu = 1;
		    }
		    else {
		    	delayClickable = setTimeout(function(){
		    		pubArgu.showBrowserMenu = 0;
		    		delayClickable = null;
		    	},400);
		    }
		}
	}

	//tagMenu 冲突及关闭
	function tagMenuConflict(){
		if(userMenu.timeout){
			clearTimeout(userMenu.timeout);
			userMenu.timeout = null;
		}
		tagMenuIcon.className = "";
		$('.fixIconBtn').removeClass('showTagMenu');
	}

	//冲突检测方法
	function clickConflictTest(){
		//是否正在播放声音检测
		if(pubArgu.listenVoiceObj){
			$(pubArgu.listenVoiceObj).removeClass('loading'); //去除loading
			$.audioPlayer.stopPlay(); //停止播放器及对应动画
		}
	}
	window.clickConflictTest = clickConflictTest;
});